﻿Module i355

    Public AllomasDb, MetroDb, ViliDb As Integer 'Az állomások, metróvonalak és villamosvonalak száma.
    Public Allomas(25000) As String 'Az állomások nevei
    Public VanMetro(25000) As Boolean 'Van-e metróvonal az egyes állomásokon
    Public MetroHossz(100), ViliHossz(100) As Integer 'A metró- és villamosvonalak hosszai. (a két végállomást is beleértve)
    Public MetroMegallo(100, 250), ViliMegallo(100, 250) As Integer 'A metró- és villamosvonalak megállóinak indexei. (0.=kezdő végállomás)
    Public MaxMetroHossz, MaxViliHossz As Integer 'Leghosszabb metró- és villamosvonal hossza (b feladathoz)

    Public VonalDb(25000) As Short 'Azt tárolja, hogy az adott állomáson hány vonal fut.
    Public Vonalak(25000, 200) As Short 'Az adott állomáson megálló vonalak. Pozitív: metró, negatív: villamos.

    Sub Main()
        Dim BeSor, Megallo As String
        Dim I, J, K As Integer

        'Beolvasás
        BeSor = Console.ReadLine
        MetroDb = BeSor.Split(" ")(0)
        ViliDb = BeSor.Split(" ")(1)
        AllomasDb = 0
        MaxMetroHossz = 0
        MaxViliHossz = 0

        For I = 1 To MetroDb 'metróvonalak beolvasása
            BeSor = Console.ReadLine
            MetroHossz(I) = BeSor.Split(" ")(0)
            If MetroHossz(I) > MaxMetroHossz Then
                MaxMetroHossz = MetroHossz(I)
            End If
            BeSor = BeSor.Substring(CStr(MetroHossz(I)).Length) 'a sorból levágjuk a vonal hosszát (amit már eltároltunk)
            For J = 0 To MetroHossz(I) - 1 'megállók eltárolása
                Megallo = BeSor.Split(",")(J).Substring(1) 'megállónév eltárolása
                MetroMegallo(I, J) = -1
                For K = 1 To AllomasDb
                    If Megallo = Allomas(K) Then 'ha már van ilyen állomás, akkor csak annak az adatait frissítjük az új vonallal
                        MetroMegallo(I, J) = K
                        VonalDb(K) += 1
                        Vonalak(K, VonalDb(K)) = I
                        VanMetro(K) = True
                        Exit For
                    End If
                Next
                If MetroMegallo(I, J) = -1 Then 'új állomást hozunk létre
                    AllomasDb += 1
                    Allomas(AllomasDb) = Megallo
                    VanMetro(AllomasDb) = True
                    VonalDb(AllomasDb) = 1
                    Vonalak(AllomasDb, 1) = I
                    MetroMegallo(I, J) = AllomasDb
                End If
            Next
        Next

        For I = 1 To ViliDb 'villamosvonalak beolvasása
            BeSor = Console.ReadLine
            ViliHossz(I) = BeSor.Split(" ")(0)
            If ViliHossz(I) > MaxViliHossz Then
                MaxViliHossz = ViliHossz(I)
            End If
            BeSor = BeSor.Substring(CStr(ViliHossz(I)).Length)
            For J = 0 To ViliHossz(I) - 1
                Megallo = BeSor.Split(",")(J).Substring(1)
                ViliMegallo(I, J) = -1
                For K = 1 To AllomasDb
                    If Megallo = Allomas(K) Then 'meglévő állomás frissítése
                        ViliMegallo(I, J) = K
                        VonalDb(K) += 1
                        Vonalak(K, VonalDb(K)) = -I
                        Exit For
                    End If
                Next
                If ViliMegallo(I, J) = -1 Then 'új állomás
                    AllomasDb += 1
                    Allomas(AllomasDb) = Megallo
                    VanMetro(AllomasDb) = False
                    VonalDb(AllomasDb) = 1
                    Vonalak(AllomasDb, 1) = -I
                    ViliMegallo(I, J) = AllomasDb
                End If
            Next
        Next

        Console.WriteLine(AllomasDb) 'a feladat
        Console.WriteLine(MaxMetroHossz & " " & MaxViliHossz) 'b feladat

        'c feladat
        Dim MetroNelkuliDb As Integer = 0 'Metró nélküli állomások száma
        Dim MetroNelkuli(100000) As String 'Metró nélküli állomások
        For I = 1 To AllomasDb 'metró nélküli állomások kigyűjtése
            If Not VanMetro(I) Then
                MetroNelkuliDb += 1
                MetroNelkuli(MetroNelkuliDb) = Allomas(I)
            End If
        Next

        If MetroNelkuliDb = 0 Then
            Console.WriteLine("Minden állomás elérhető metróval.")
        Else
            For I = 1 To MetroNelkuliDb - 1
                Console.Write(MetroNelkuli(I) & ", ")
            Next
            Console.WriteLine(MetroNelkuli(MetroNelkuliDb))
        End If


        'd és e feladat
        Dim Start As Integer
        'Az aktuális kezdőállomás, ahonnan a távolságokat és átszállásszámokat nézzük

        Dim MaxTav, MaxCel As Integer
        'Az aktuális kezdőállomástól vett maximális távolság, és a hozzá tartozó célállomás

        Dim MaxAtszDb, MaxAtszCel As Integer
        'Az aktuális kezdőállomástól vett maximális átszállásszám, és a hozzá tartozó célállomás

        Dim MaxMaxTav, MaxMaxStart, MaxMaxCel As Integer
        'Az abszolút maximális távolság, és a hozzá tartozó kezdő- és célállomás

        Dim MaxMaxAtszDb, MaxMaxAtszStart, MaxMaxAtszCel As Integer
        'Az abszolút maximális átszállásszám, és a hozzá tartozó kezdő- és célállomás

        Dim Tav(AllomasDb), AtszDb(AllomasDb) As Integer
        'állomásonként a kezdőállomástól vett távolság (megállókban) és szükséges átszállások száma

        Dim Valtozas As Boolean 'azt tárolom itt, hogy történt-e az adott ciklusfutásban változás, azaz van-e még értelme ismételni

        MaxMaxTav = 0
        MaxMaxAtszDb = 0
        For Start = 1 To AllomasDb - 1

            'az összes állomás távolságát és átszállásszámát kezdetben 99999-re állítjuk be, ez azt jelenti, hogy még nem értük el a starttól
            For I = 1 To AllomasDb
                Tav(I) = 99999
                AtszDb(I) = 99999
            Next

            'a startállomás önmagától vett távolsága 0, innen indul majd a távolság- és átszállástömb számokkal való kitöltése
            Tav(Start) = 0
            'a start önmagától vett átszállásszáma azért -1, mert az átszállásszámot (a szükséges járatok száma - 1)-ként definiálom
            AtszDb(Start) = -1

            'A távolság- és átszállástömböt kitöltő ciklus
            Do
                Valtozas = False
                For I = 1 To MetroDb 'minden metróvonal
                    For J = 0 To MetroHossz(I) - 1 'minden megállójára
                        If Tav(MetroMegallo(I, J)) < 99999 Then 'ha már elértük a megállót
                            For K = 0 To MetroHossz(I) - 1 'akkor a vonal mentén minden megállóra 
                                If Tav(MetroMegallo(I, J)) + Math.Abs(K - J) < Tav(MetroMegallo(I, K)) Then
                                    'ha a K-adik megálló az eddigi távolságnál gyorsabban elérhető úgy, 
                                    'hogy a J-ediktől az I metróval megyünk oda, akkor frissítjük a távolságát
                                    Valtozas = True
                                    Tav(MetroMegallo(I, K)) = Tav(MetroMegallo(I, J)) + Math.Abs(K - J)
                                End If
                                If AtszDb(MetroMegallo(I, J)) + 1 < AtszDb(MetroMegallo(I, K)) Then
                                    'ha a K-adik megálló az eddigi átszállásszámnál kevesebb átszállással elérhető úgy, 
                                    'hogy a J-ediktől az I metróval megyünk oda, akkor frissítjük az átsz. számot
                                    Valtozas = True
                                    AtszDb(MetroMegallo(I, K)) = AtszDb(MetroMegallo(I, J)) + 1
                                End If
                            Next
                        End If
                    Next
                Next
                For I = 1 To ViliDb 'minden villamosvonal
                    For J = 0 To ViliHossz(I) - 1 'minden megállójára
                        If Tav(ViliMegallo(I, J)) < 99999 Then 'ha már elértük a megállót
                            For K = 0 To ViliHossz(I) - 1 'akkor a vonal mentén minden megállóra
                                If Tav(ViliMegallo(I, J)) + Math.Abs(K - J) < Tav(ViliMegallo(I, K)) Then
                                    'ha a K-adik megálló az eddigi távolságnál gyorsabban elérhető úgy, 
                                    'hogy a J-ediktől az I villamossal megyünk oda, akkor frissítjük a távolságát
                                    Valtozas = True
                                    Tav(ViliMegallo(I, K)) = Tav(ViliMegallo(I, J)) + Math.Abs(K - J)
                                End If
                                If AtszDb(ViliMegallo(I, J)) + 1 < AtszDb(ViliMegallo(I, K)) Then
                                    'ha a K-adik megálló az eddigi átszállásszámnál kevesebb átszállással elérhető úgy, 
                                    'hogy a J-ediktől az I villamossal megyünk oda, akkor frissítjük az átsz. számot
                                    Valtozas = True
                                    AtszDb(ViliMegallo(I, K)) = AtszDb(ViliMegallo(I, J)) + 1
                                End If
                            Next
                        End If
                    Next
                Next
            Loop While Valtozas

            'Maximális távolság kikeresése
            MaxTav = 0
            For I = 1 To AllomasDb
                If (Tav(I) > MaxTav) And (Tav(I) < 99999) Then
                    MaxTav = Tav(I)
                    MaxCel = I
                End If
            Next

            'Ha az abszolút maximumnál nagyobb a mostani max. távolság, akkor frissítjük a maximumot
            If MaxTav > MaxMaxTav Then
                MaxMaxTav = MaxTav
                MaxMaxStart = Start
                MaxMaxCel = MaxCel
            End If

            'Maximális átszállásszám kigyűjtése
            MaxAtszDb = 0
            For I = 1 To AllomasDb
                If (AtszDb(I) > MaxAtszDb) And (AtszDb(I) < 99999) Then
                    MaxAtszDb = AtszDb(I)
                    MaxAtszCel = I
                End If
            Next

            'Ha az abszolút maximumnál nagyobb a mostani max. átszállásszám, akkor frissítjük a maximumot
            If MaxAtszDb > MaxMaxAtszDb Then
                MaxMaxAtszDb = MaxAtszDb
                MaxMaxAtszStart = Start
                MaxMaxAtszCel = MaxAtszCel
            End If
        Next

        'eredmények kiírása
        Console.WriteLine(Allomas(MaxMaxStart) & ", " & Allomas(MaxMaxCel) & ", " & MaxMaxTav)
        Console.WriteLine(MaxMaxAtszDb & ", " & Allomas(MaxMaxAtszStart) & ", " & Allomas(MaxMaxAtszCel))
        Console.ReadLine()
    End Sub

End Module
